<?php

  // Inicia a classe de instalao
  class Instala {
    
    // Declara as variveis de uso neste classe
    var $error_code;
    var $host;
    var $conta;
    var $senha;
    var $database;
    var $prefixo;
    
    // Funo para receber os dados enviados
    function Recebe_Dados() {
      
      // Recebe o host
      $this->host = htmlspecialchars (trim (stripslashes ($_POST["host"])), ENT_QUOTES);
      
      // Recebe a conta de acesso
      $this->conta = htmlspecialchars (trim (stripslashes ($_POST["conta"])), ENT_QUOTES);
      
      // Recebe a senha de acesso
      $this->senha = htmlspecialchars (trim (stripslashes ($_POST["senha"])), ENT_QUOTES);
      
      // Recebe o banco de dados
      $this->database = htmlspecialchars (trim (stripslashes ($_POST["database"])), ENT_QUOTES);
      
      // Recebe o prefixo de nomenclatura
      $this->prefixo = strtolower (htmlspecialchars (trim (stripslashes ($_POST["prefixo"])), ENT_QUOTES));
      
    }
    
    // Funo para validar os dados recebidos
    function Valida_Dados() {
      
      // Verifica se  possvel se conectar ao mySQL com os dados informados
      if (!mysql_connect ($this->host, $this->conta, $this->senha)) {
        
        $this->error_code += 1;
        
      }
      
      // Verifica se o banco de dados existe
      if (!mysql_select_db ($this->database)) {
        
        $this->error_code += 2;
        
      }
      
      // Verifica o formato do prefixo
      $this->prefixo = eregi_replace ("[^a-z]", "", $this->prefixo);
      $total = substr_count ($this->prefixo, "");
      if ($total != 0) {
        
        $this->error_code += 4;
        
      }
      
    }
    
    // Funo que redireciona caso erros run-time sejam encontrados
    function Reinstalar() {
      
      // Verifica se a varivel de erros est modificada
      if ($this->error_code != 0) {
        
        header ("Location: Install.php?error_code=$this->error_code");
        
      }
      
    }
    
    // Funo para criar as tabelas de armazenamento
    function Cria_Tabelas() {
      
      // Cria o nome da tabela
      $tabela = (!empty ($this->prefixo)) ? $this->prefixo . "_netstat" : "klaus_netstat";
      define ("Tabela", $tabela);
      
      // Define o nome dos campos
      define ("CampoA", "guest"); // Host e IP do visitante
      define ("CampoB", "time"); // Momento da Visita
      define ("CampoC", "url"); // URL de visualizao
      
      // Query para criao da tabela
      $query = "CREATE TABLE " . Tabela . " (" . CampoA . " TEXT NOT NULL, " . CampoB . " DATETIME NOT NULL, " . CampoC . " TEXT NOT NULL)";
      
      // Execuo da query
      mysql_query ($query);
      
    }
    
    // Funo para criar o arquivo de configuraes
    function Cria_Config() {
      
      // Define o caminho para o arquivo de configuraes
      $arquivo = "Includes/configuration.inc.php";
      
      // Abre o arquivo para escrita (w)
      $ponteiro = fopen ($arquivo, "w");
      
      // Define o contedo do arquivo
      $conteudo = "<?php
      
  // mySQL
  define (\"Host\", \"" . $this->host . "\");
  define (\"Conta\", \"" . $this->conta . "\");
  define (\"Senha\", \"" . $this->senha . "\");
  define (\"Database\", \"" . $this->database . "\");
  define (\"Prefixo\", \"" . $this->prefixo . "\");
      
  // Tabelas e Campos
  define (\"Tabela\", \"" . Tabela . "\");
  define (\"CampoA\", \"" . CampoA . "\");
  define (\"CampoB\", \"" . CampoB . "\");
  define (\"CampoC\", \"" . CampoC . "\");
      
?>";
      
      // Insere o conteudo no arquivo
      fwrite ($ponteiro, $conteudo);
      
      // Encerra a criao do arquivo
      fclose ($ponteiro);
      
    }
    
    function Redireciona() {
      
      header ("Location: Sucess.php");
      
    }
    
  }
  
  $install = new Instala();
  $install->Recebe_Dados();
  $install->Valida_Dados();
  $install->Reinstalar();
  $install->Cria_Tabelas();
  $install->Cria_Config();
  $install->Redireciona();

?>